#!/usr/bin/perl
# Estrae le parole uniche da un testo
# Autore: Franco, IK7XJA
# recupero la variabile con il nome del file:
my $file = $ARGV[0] ;
# se il file è valido ed esiste:
if ($file) {
   if (-e $file) {
      # inizializzo l'array che conterrà il testo
      undef my @righe ;
      # apro il file
      open(IN, "< $file") ;
         @righe = <IN>;
      close(IN);
      # pulizia dei caratteri e sostituzione accenti
      undef my %Parole ;
      my $Max_length = 0 ;
      foreach my $R(@righe) {
         # pongo ogni parola in minuscolo
         $R = lc($R) ;
         # elimino i caratteri speciali e le
         # punteggiature usando espressioni regolari
         $R =~ s/à/a/g ;
         $R =~ s/è/e/g ;
         $R =~ s/é/e/g ;
         $R =~ s/ì/i/g ;
         $R =~ s/ò/o/g ;
         $R =~ s/ù/u/g ;
         $R =~ s/\.//g ;
         $R =~ s/,//g ;
         $R =~ s/;//g ;
         $R =~ s/://g ;
         $R =~ s/\!//g ;
         $R =~ s/\?//g ;
         $R =~ s/\'/ /g ;
         $R =~ s/\"//g ;
         $R =~ s/\n//g ;
         $R =~ s/\r//g ;
         # Divido ogni rigo in parole
         my @Words = split / +/, $R ;
         foreach my $W(@Words) {
            # accumulo le parole solo se non già prese
            # e ne calcolo la lunghezza per ordinarle
            # inoltre, prendo solo quelle con più di due caratteri
            if (length($W)>2) {
               $W = uc($W) ;
               if (!defined($Parole{$W})) {
                  $Parole{$W} = 1 ;
                  if (length($W)>$Max_length) {
                     $Max_length = length($W) ;
                  }
               }
            }
         }
      }
      # ordino le parole per lunghezza
      undef my %Lunghezze ;
      foreach my $P(keys %Parole) {
         my $Lun = sprintf("%02d", length($P)) ;
         push(@{$Lunghezze{$Lun}}, $P) ;
      }
      # in outuput, ho le parole del testo ordinate
      my $Rigo = '' ;
      foreach my $L(sort keys %Lunghezze) {
         foreach my $Parola(sort @{$Lunghezze{$L}}) {
            $Rigo .= "$Parola " ;
            if (length($Rigo)>55) {
               print " $Rigo\n" ;
               $Rigo = '' ;
            }
         }
      }
   } else {
      print "Il file indicato non esiste\n\n" ;
   }
} else {
   print "Indicare un testo\n\n" ;
}
exit ;